<template>
  <AppButton
    :classes="['buttonCart']"
    @click.native="addPartToCart(); $ym('add_to_cart');$ga('Enter2','Click35')"
    @mouseleave="maxQuantityTooltip = null"
    v-tooltip="getTooltipCart()">
    <span
      v-if="!isPartInCart()"
      slot="button-item"
      class="button-item">
      <img
        svg-inline
        src="~/assets/svg/redesign/basket.svg">
      В корзину
    </span>
    <span
      v-else
      slot="button-item"
      class="button-item">
      В корзине
      <img
        svg-inline
        src="~/assets/svg/redesign/checked.svg">

    </span>
  </AppButton>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';
import { ADD_ITEMS } from '~/assets/js/store/cart/action-types';
import Item from '~/assets/js/model/item/item';
import AppButton from '~/components/redesign/app-buttons/app-button';

const STORE_CART = createNamespacedHelpers('cart');
export default {
  name: 'AppAddCartControl',
  components: {
    AppButton,
  },
  props: {
    entity: {
      type: Object,
      default() { return {}; },
    },
  },
  data() {
    return {
      addingParts: [],
      maxQuantityTooltip: null,
      timerId: null,
    };
  },
  computed: {
    ...STORE_CART.mapGetters({
      isInCart: 'isInCart',
      cartItems: 'items',
      itemQuantity: 'itemQuantity',
    }),
    ...STORE_CART.mapState({
      isAdded: 'isAdded',
    }),
  },
  methods: {
    ...STORE_CART.mapActions({
      addItems: ADD_ITEMS,
    }),
    addPartToCart() {
      // TODO: Need refactoring
      // TODO: ИМХО все действия с корзиной нужно вынести на уровень стора.
      //  После этого избавиться от компонента.
      if (this.isAdded) {
        setTimeout(() => {
          this.addPartToCart(this.entity);
        }, 50);

        return;
      }

      this.$statPpn('click-add-to-cart', this.getStatData(this.entity));

      if (this.entity.quantity && this.quantityInCart(this.entity) >= this.entity.quantity) {
        this.maxQuantityTooltip = this.entity.item_id;
      } else {
        this.addingParts.push(new Item({
          ...this.entity,
          maxQuantity: this.entity.quantity,
          quantity: 1,
        }));
      }

      if (this.timerId) {
        return;
      }

      this.timerId = setTimeout(() => {
        this.timerId = null;

        if (this.addingParts.length) {
          this.addItems(this.addingParts);
          this.addingParts = [];
        }
      }, 300);
    },
    getStatData() {
      return {
        shopId: this.entity.shop_id,
        brandId: this.entity.part_manufacturer_id,
        partId: this.entity.part_id,
        itemId: this.entity.item_id,
        itemName: this.entity.item_name,
        brandName: this.entity.brand,
        partNumber: this.entity.vendor_code,
        partName: this.entity.part_name,
      };
    },
    quantityInCart() {
      return this.itemQuantity(new Item(this.entity));
    },
    getTooltipCart() {
      return {
        classes: 'tooltip kit dark desktopshow',
        content: 'Вы пытаетесь превысить допустимое количество',
        placement: 'left-start',
        trigger: 'manual',
        offset: 8,
        show: this.quantityInCart(this.entity) === this.entity.quantity
          && this.maxQuantityTooltip === this.entity.item_id,
      };
    },
    isPartInCart() {
      return Boolean(this.isInCart(new Item(this.entity)));
    },
  },
};
</script>

<style lang="postcss">
  @media (min-width: 981px) and (max-width: 1200px) {
    .partInfo {
      .sellerOrder {
        flex-direction: row;

        .buttonCart {
          margin-left: 0.75rem;
          font-size: 0;
          .svg {
            display: block;
          }
        }
      }
    }
  }

</style>
